diff --git a/rtemsbsd/sys/fs/devfs/devfs_devs.c b/rtemsbsd/sys/fs/devfs/devfs_devs.c
index 7c697b0a..39a38d62 100644
--- a/rtemsbsd/sys/fs/devfs/devfs_devs.c
+++ b/rtemsbsd/sys/fs/devfs/devfs_devs.c
@@ -35,6 +35,7 @@
 #include <sys/conf.h>
 #include <sys/kernel.h>
 #include <sys/file.h>
+#include <sys/filedesc.h>
 #include <sys/malloc.h>
 #include <sys/proc.h>
 #include <sys/poll.h>
@@ -42,6 +43,8 @@
 #include <string.h>
 #include <unistd.h>
 
+#include <machine/rtems-bsd-libio.h>
+
 #include <fs/devfs/devfs_int.h>
 
 #include <machine/pcpu.h>
@@ -72,17 +75,25 @@ static int
 devfs_imfs_open(rtems_libio_t *iop, const char *path, int oflag, mode_t mode)
 {
 	struct cdev *cdev = devfs_imfs_get_context_by_iop(iop);
-	struct file *fp = rtems_bsd_iop_to_fp(iop);
 	struct thread *td = rtems_bsd_get_curthread_or_null();
+	struct file *fp = NULL;
+	struct cdevsw *dsw = NULL;
 	struct file *fpop;
-	struct cdevsw *dsw;
 	int error, ref;
+	int fd = -1;
 
 	if (td != NULL) {
 		if (cdev == NULL) {
 			error = ENXIO;
 			goto err;
 		}
+		error = falloc(td, &fp, &fd, oflag);
+		if (error != 0)
+			goto err;
+		finit(fp, FREAD | FWRITE, DTYPE_DEV, NULL, NULL);
+		rtems_libio_iop_hold(iop);
+		rtems_bsd_libio_iop_set_bsd_descriptor(iop, fd);
+		rtems_bsd_libio_iop_set_bsd_file(iop, fp);
 		if (cdev->si_flags & SI_ALIAS) {
 			cdev = cdev->si_parent;
 		}
@@ -91,11 +102,6 @@ devfs_imfs_open(rtems_libio_t *iop, const char *path, int oflag, mode_t mode)
 			error = ENXIO;
 			goto err;
 		}
-		if (fp == NULL) {
-			dev_relthread(cdev, ref);
-			error = ENXIO;
-			goto err;
-		}
 		fpop = td->td_fpop;
 		curthread->td_fpop = fp;
 		fp->f_cdevpriv = NULL;
@@ -104,12 +110,19 @@ devfs_imfs_open(rtems_libio_t *iop, const char *path, int oflag, mode_t mode)
 		if (error != 0)
 			devfs_clear_cdevpriv();
 		curthread->td_fpop = fpop;
-		dev_relthread(cdev, ref);
 	} else {
 		error = ENOMEM;
 	}
 
 err:
+	if (dsw != NULL)
+		dev_relthread(cdev, ref);
+	if (td != NULL && fp != NULL) {
+		if (error != 0)
+			fdclose(td, fp, fd);
+		else
+			fdrop(fp, td);
+	}
 	return rtems_bsd_error_to_status_and_errno(error);
 }
 
@@ -117,11 +130,11 @@ static int
 devfs_imfs_close(rtems_libio_t *iop)
 {
 	struct cdev *cdev = devfs_imfs_get_context_by_iop(iop);
-	struct file *fp = rtems_bsd_iop_to_fp(iop);
 	struct thread *td = rtems_bsd_get_curthread_or_null();
 	int flags = rtems_libio_to_fcntl_flags(iop->flags);
+	struct file *fp = NULL;
+	struct cdevsw *dsw = NULL;
 	struct file *fpop;
-	struct cdevsw *dsw;
 	int error, ref;
 
 	if (td != NULL) {
@@ -132,6 +145,11 @@ devfs_imfs_close(rtems_libio_t *iop)
 		if (cdev->si_flags & SI_ALIAS) {
 			cdev = cdev->si_parent;
 		}
+		fp = rtems_bsd_libio_iop_to_file_hold(iop, td);
+		if (fp == NULL) {
+			error = EBADF;
+			goto err;
+		}
 		dsw = dev_refthread(cdev, &ref);
 		if (dsw == NULL) {
 			error = ENXIO;
@@ -141,7 +159,6 @@ devfs_imfs_close(rtems_libio_t *iop)
 		curthread->td_fpop = fp;
 		error = dsw->d_close(cdev, flags, 0, td);
 		curthread->td_fpop = fpop;
-		dev_relthread(cdev, ref);
 		if (fp->f_cdevpriv != NULL)
 			devfs_fpdrop(fp);
 	} else {
@@ -149,6 +166,10 @@ devfs_imfs_close(rtems_libio_t *iop)
 	}
 
 err:
+	if (dsw != NULL)
+		dev_relthread(cdev, ref);
+	if (td != NULL && fp != NULL)
+		fdrop(fp, td);
 	return rtems_bsd_error_to_status_and_errno(error);
 }
 
@@ -157,7 +178,6 @@ devfs_imfs_readv(rtems_libio_t *iop, const struct iovec *iov, int iovcnt,
     ssize_t total)
 {
 	struct cdev *cdev = devfs_imfs_get_context_by_iop(iop);
-	struct file *fp = rtems_bsd_iop_to_fp(iop);
 	struct thread *td = rtems_bsd_get_curthread_or_null();
 	struct uio uio = {
 		.uio_iov = __DECONST(struct iovec *, iov),
@@ -168,8 +188,9 @@ devfs_imfs_readv(rtems_libio_t *iop, const struct iovec *iov, int iovcnt,
 		.uio_rw = UIO_READ,
 		.uio_td = td
 	};
+	struct file *fp = NULL;
+	struct cdevsw *dsw = NULL;
 	struct file *fpop;
-	struct cdevsw *dsw;
 	int error, ref;
 
 	if (td != NULL) {
@@ -180,6 +201,11 @@ devfs_imfs_readv(rtems_libio_t *iop, const struct iovec *iov, int iovcnt,
 		if (cdev->si_flags & SI_ALIAS) {
 			cdev = cdev->si_parent;
 		}
+		fp = rtems_bsd_libio_iop_to_file_hold(iop, td);
+		if (fp == NULL) {
+			error = EBADF;
+			goto err;
+		}
 		dsw = dev_refthread(cdev, &ref);
 		if (dsw == NULL) {
 			error = ENXIO;
@@ -190,12 +216,15 @@ devfs_imfs_readv(rtems_libio_t *iop, const struct iovec *iov, int iovcnt,
 		error = dsw->d_read(cdev, &uio,
 		    rtems_libio_to_fcntl_flags(iop->flags));
 		td->td_fpop = fpop;
-		dev_relthread(cdev, ref);
 	} else {
 		error = ENOMEM;
 	}
 
 err:
+	if (dsw != NULL)
+		dev_relthread(cdev, ref);
+	if (td != NULL && fp != NULL)
+		fdrop(fp, td);
 	if (error == 0) {
 		return (total - uio.uio_resid);
 	} else {
@@ -219,7 +248,6 @@ devfs_imfs_writev(rtems_libio_t *iop, const struct iovec *iov, int iovcnt,
     ssize_t total)
 {
 	struct cdev *cdev = devfs_imfs_get_context_by_iop(iop);
-	struct file *fp = rtems_bsd_iop_to_fp(iop);
 	struct thread *td = rtems_bsd_get_curthread_or_null();
 	struct uio uio = {
 		.uio_iov = __DECONST(struct iovec *, iov),
@@ -230,8 +258,9 @@ devfs_imfs_writev(rtems_libio_t *iop, const struct iovec *iov, int iovcnt,
 		.uio_rw = UIO_WRITE,
 		.uio_td = td
 	};
+	struct file *fp = NULL;
+	struct cdevsw *dsw = NULL;
 	struct file *fpop;
-	struct cdevsw *dsw;
 	int error, ref;
 
 	if (td != NULL) {
@@ -242,6 +271,11 @@ devfs_imfs_writev(rtems_libio_t *iop, const struct iovec *iov, int iovcnt,
 		if (cdev->si_flags & SI_ALIAS) {
 			cdev = cdev->si_parent;
 		}
+		fp = rtems_bsd_libio_iop_to_file_hold(iop, td);
+		if (fp == NULL) {
+			error = EBADF;
+			goto err;
+		}
 		dsw = dev_refthread(cdev, &ref);
 		if (dsw == NULL) {
 			error = ENXIO;
@@ -252,12 +286,15 @@ devfs_imfs_writev(rtems_libio_t *iop, const struct iovec *iov, int iovcnt,
 		error = dsw->d_write(cdev, &uio,
 		    rtems_libio_to_fcntl_flags(iop->flags));
 		td->td_fpop = fpop;
-		dev_relthread(cdev, ref);
 	} else {
 		error = ENOMEM;
 	}
 
 err:
+	if (dsw != NULL)
+		dev_relthread(cdev, ref);
+	if (td != NULL && fp != NULL)
+		fdrop(fp, td);
 	if (error == 0) {
 		return (total - uio.uio_resid);
 	} else {
@@ -280,10 +317,10 @@ static int
 devfs_imfs_ioctl(rtems_libio_t *iop, ioctl_command_t request, void *buffer)
 {
 	struct cdev *cdev = devfs_imfs_get_context_by_iop(iop);
-	struct file *fp = rtems_bsd_iop_to_fp(iop);
 	struct thread *td = rtems_bsd_get_curthread_or_null();
+	struct file *fp = NULL;
+	struct cdevsw *dsw = NULL;
 	struct file *fpop;
-	struct cdevsw *dsw;
 	int error, ref;
 	int flags = rtems_libio_to_fcntl_flags(iop->flags);
 
@@ -295,6 +332,11 @@ devfs_imfs_ioctl(rtems_libio_t *iop, ioctl_command_t request, void *buffer)
 		if (cdev->si_flags & SI_ALIAS) {
 			cdev = cdev->si_parent;
 		}
+		fp = rtems_bsd_libio_iop_to_file_hold(iop, td);
+		if (fp == NULL) {
+			error = EBADF;
+			goto err;
+		}
 		dsw = dev_refthread(cdev, &ref);
 		if (dsw == NULL) {
 			error = ENXIO;
@@ -305,12 +347,15 @@ devfs_imfs_ioctl(rtems_libio_t *iop, ioctl_command_t request, void *buffer)
 		error = dsw->d_ioctl(cdev, request, buffer, flags,
 		    td);
 		td->td_fpop = fpop;
-		dev_relthread(cdev, ref);
 	} else {
 		error = ENOMEM;
 	}
 
 err:
+	if (dsw != NULL)
+		dev_relthread(cdev, ref);
+	if (td != NULL && fp != NULL)
+		fdrop(fp, td);
 	return rtems_bsd_error_to_status_and_errno(error);
 }
 
@@ -333,28 +378,43 @@ static int
 devfs_imfs_poll(rtems_libio_t *iop, int events)
 {
 	struct cdev *cdev = devfs_imfs_get_context_by_iop(iop);
-	struct file *fp = rtems_bsd_iop_to_fp(iop);
 	struct thread *td = rtems_bsd_get_curthread_or_wait_forever();
+	struct file *fp = NULL;
+	struct cdevsw *dsw = NULL;
 	struct file *fpop;
-	struct cdevsw *dsw;
 	int error, ref;
 
-	if (cdev == NULL) {
-		return POLLERR;
-	}
-	if (cdev->si_flags & SI_ALIAS) {
-		cdev = cdev->si_parent;
-	}
-	dsw = dev_refthread(cdev, &ref);
-	if (dsw == NULL) {
-		return POLLERR;
+	if (td != 0) {
+		if (cdev == NULL) {
+			error = POLLERR;
+			goto err;
+		}
+		if (cdev->si_flags & SI_ALIAS) {
+			cdev = cdev->si_parent;
+		}
+		fp = rtems_bsd_libio_iop_to_file_hold(iop, td);
+		if (fp == NULL) {
+			error = EBADF;
+			goto err;
+		}
+		dsw = dev_refthread(cdev, &ref);
+		if (dsw == NULL) {
+			error = POLLERR;
+			goto err;
+		}
+		fpop = td->td_fpop;
+		curthread->td_fpop = fp;
+		error = dsw->d_poll(cdev, events, td);
+		td->td_fpop = fpop;
+	} else {
+		error = ENOMEM;
 	}
-	fpop = td->td_fpop;
-	curthread->td_fpop = fp;
-	error = dsw->d_poll(cdev, events, td);
-	td->td_fpop = fpop;
-	dev_relthread(cdev, ref);
 
+err:
+	if (dsw != NULL)
+		dev_relthread(cdev, ref);
+	if (td != NULL && fp != NULL)
+		fdrop(fp, td);
 	return error;
 }
 
@@ -362,28 +422,41 @@ static int
 devfs_imfs_kqfilter(rtems_libio_t *iop, struct knote *kn)
 {
 	struct cdev *cdev = devfs_imfs_get_context_by_iop(iop);
-	struct file *fp = rtems_bsd_iop_to_fp(iop);
 	struct thread *td = rtems_bsd_get_curthread_or_wait_forever();
+	struct file *fp = NULL;
+	struct cdevsw *dsw = NULL;
 	struct file *fpop;
-	struct cdevsw *dsw;
 	int error, ref;
 
-	if (cdev == NULL) {
-		return EINVAL;
-	}
-	if (cdev->si_flags & SI_ALIAS) {
-		cdev = cdev->si_parent;
-	}
-	dsw = dev_refthread(cdev, &ref);
-	if (dsw == NULL) {
-		return EINVAL;
+	if (td != 0) {
+		if (cdev == NULL) {
+			error = EINVAL;
+		}
+		fp = rtems_bsd_libio_iop_to_file_hold(iop, td);
+		if (fp == NULL) {
+			error = EBADF;
+			goto err;
+		}
+		if (cdev->si_flags & SI_ALIAS) {
+			cdev = cdev->si_parent;
+		}
+		dsw = dev_refthread(cdev, &ref);
+		if (dsw == NULL) {
+			error = EINVAL;
+		}
+		fpop = td->td_fpop;
+		curthread->td_fpop = fp;
+		error = dsw->d_kqfilter(cdev, kn);
+		td->td_fpop = fpop;
+	} else {
+		error = ENOMEM;
 	}
-	fpop = td->td_fpop;
-	curthread->td_fpop = fp;
-	error = dsw->d_kqfilter(cdev, kn);
-	td->td_fpop = fpop;
-	dev_relthread(cdev, ref);
 
+err:
+	if (dsw != NULL)
+		dev_relthread(cdev, ref);
+	if (td != NULL && fp != NULL)
+		fdrop(fp, td);
 	return error;
 }
 
diff --git a/testsuite/include/rtems/bsd/test/default-init.h b/testsuite/include/rtems/bsd/test/default-init.h
index f8ea3acd..fd96805b 100644
--- a/testsuite/include/rtems/bsd/test/default-init.h
+++ b/testsuite/include/rtems/bsd/test/default-init.h
@@ -14,6 +14,13 @@
 #include <rtems/stackchk.h>
 #include <rtems/bsd/bsd.h>
 
+/*
+ * Work around the need for this declr and not being able to include sys/ioctl.h.
+ *
+ * rtems/bdbuf.h have a call to it
+ */
+int ioctl(int fd, unsigned long request, ...);
+
 static void default_set_self_prio( rtems_task_priority prio )
 {
   rtems_status_code sc;
diff --git a/testsuite/swi01/init.c b/testsuite/swi01/init.c
index d1de191a..af6f07c6 100644
--- a/testsuite/swi01/init.c
+++ b/testsuite/swi01/init.c
@@ -50,9 +50,6 @@
 
 #define TEST_NAME "LIBBSD SOFTWARE INTERRUPT 1"
 
-uintptr_t rtems_bsd_allocator_domain_page_mbuf_size =
-    RTEMS_BSD_ALLOCATOR_DOMAIN_PAGE_MBUF_DEFAULT;
-
 static void Init(rtems_task_argument arg)
 {
 	rtems_status_code sc;
diff --git a/testsuite/syscalls01/test_main.c b/testsuite/syscalls01/test_main.c
index 1116890f..3cfda667 100644
--- a/testsuite/syscalls01/test_main.c
+++ b/testsuite/syscalls01/test_main.c
@@ -65,6 +65,8 @@
 #include <rtems/bsd/modules.h>
 #include <rtems/libcsupport.h>
 
+#include <rtems/libio_.h>
+
 #define TEST_NAME "LIBBSD SYSCALLS 1"
 
 typedef void (*no_mem_test_body)(int fd);
@@ -94,6 +96,7 @@ static socket_test socket_tests[] = {
 	{ PF_INET, SOCK_DGRAM, 0, 0 },
 	{ PF_INET, SOCK_SEQPACKET, 0, EPROTOTYPE },
 	{ PF_INET, SOCK_RAW, IPPROTO_3PC, 0 },
+
 	{ PF_INET, SOCK_RAW, IPPROTO_ADFS, 0 },
 	{ PF_INET, SOCK_RAW, IPPROTO_AH, 0 },
 	{ PF_INET, SOCK_RAW, IPPROTO_AHIP, 0 },
@@ -104,6 +107,7 @@ static socket_test socket_tests[] = {
 	{ PF_INET, SOCK_RAW, IPPROTO_BLT, 0 },
 	{ PF_INET, SOCK_RAW, IPPROTO_BRSATMON, 0 },
 	{ PF_INET, SOCK_RAW, IPPROTO_CARP, 0 },
+
 	{ PF_INET, SOCK_RAW, IPPROTO_CFTP, 0 },
 	{ PF_INET, SOCK_RAW, IPPROTO_CHAOS, 0 },
 	{ PF_INET, SOCK_RAW, IPPROTO_CMTP, 0 },
@@ -112,6 +116,7 @@ static socket_test socket_tests[] = {
 	{ PF_INET, SOCK_RAW, IPPROTO_DDP, 0 },
 	{ PF_INET, SOCK_RAW, IPPROTO_DGP, 0 },
 	{ PF_INET, SOCK_RAW, IPPROTO_DSTOPTS, 0 },
+
 	{ PF_INET, SOCK_RAW, IPPROTO_EGP, 0 },
 	{ PF_INET, SOCK_RAW, IPPROTO_EMCON, 0 },
 	{ PF_INET, SOCK_RAW, IPPROTO_ENCAP, 0 },
@@ -368,7 +373,7 @@ test_sockets(void)
 	size_t n = sizeof(socket_tests) / sizeof(socket_tests[0]);
 	size_t i;
 
-	puts("test sockets");
+	puts("Test Sockets");
 
 	for (i = 0; i < n; ++i) {
 		const socket_test *st = &socket_tests[i];
@@ -441,7 +446,8 @@ no_mem_socket_fstat(int fd)
 	int rv;
 
 	rv = fstat(fd, &st);
-	assert(rv == 0);
+	assert(rv == -1);
+	assert(errno == ENOMEM);
 }
 
 static void
@@ -450,7 +456,8 @@ no_mem_socket_shutdown(int fd)
 	int rv;
 
 	rv = shutdown(fd, SHUT_RDWR);
-	assert(rv == 0);
+	assert(rv == -1);
+	assert(errno == ENOMEM);
 }
 
 static void
@@ -1591,12 +1598,12 @@ test_kqueue_unsupported_ops(void)
 	errno = 0;
 	n = read(kq, &buf[0], sizeof(buf));
 	assert(n == -1);
-	assert(errno == ENOTSUP);
+	assert(errno == EOPNOTSUPP);
 
 	errno = 0;
 	n = write(kq, &buf[0], sizeof(buf));
 	assert(n == -1);
-	assert(errno == ENOTSUP);
+	assert(errno == EOPNOTSUPP);
 
 	errno = 0;
 	rv = ioctl(kq, 0);
@@ -1636,7 +1643,8 @@ no_mem_kqueue_fstat(int fd)
 	int rv;
 
 	rv = fstat(fd, &st);
-	assert(rv == 0);
+	assert(rv == -1);
+	assert(errno == ENOMEM);
 }
 
 static void
diff --git a/testsuite/thread01/test_main.c b/testsuite/thread01/test_main.c
index 9d5e5bba..8dd77e88 100644
--- a/testsuite/thread01/test_main.c
+++ b/testsuite/thread01/test_main.c
@@ -278,6 +278,16 @@ test_kthread_add(void)
 static void
 test_rtems_bsd_get_curthread_or_null(void)
 {
+#ifdef TEST_IS_BROKEN
+	/*
+	 * This part of test relies on nothing calling
+	 * rtems_bsd_get_current.*() before getting here so the workspace
+	 * can be consumed and the allocation fails. Changes in other
+	 * areas of libbsd have resulted in `Init` having a struct thread
+	 * object allocated.
+	 *
+	 * Maybe creating a new thread and using that would be a more stable test.
+	 */
 	rtems_resource_snapshot snapshot;
 	void *greedy;
 
@@ -290,12 +300,12 @@ test_rtems_bsd_get_curthread_or_null(void)
 	rtems_workspace_greedy_free(greedy);
 
 	rtems_resource_snapshot_take(&snapshot);
+#endif
 }
 
 static void
 test_main(void)
 {
-
 	main_task_id = rtems_task_self();
 
 	/*
diff --git a/testsuite/timeout01/init.c b/testsuite/timeout01/init.c
index 6dfacd34..b2162038 100644
--- a/testsuite/timeout01/init.c
+++ b/testsuite/timeout01/init.c
@@ -48,9 +48,6 @@
 
 #define TEST_NAME "LIBBSD TIMEOUT 1"
 
-uintptr_t rtems_bsd_allocator_domain_page_mbuf_size =
-    RTEMS_BSD_ALLOCATOR_DOMAIN_PAGE_MBUF_DEFAULT;
-
 static void Init(rtems_task_argument arg)
 {
 	rtems_status_code sc;
diff --git a/wscript b/wscript
index f1577224..bfdcc91c 100644
--- a/wscript
+++ b/wscript
@@ -145,7 +145,9 @@ def options(opt):
                    action="store",
                    default="",
                    dest="freebsd_options",
-                   help="Set FreeBSD options (developer option).")
+                   help="Set FreeBSD options (developer option). Supported: " + \
+                   "bootverbose,verbose_sysinit,debug_locks,ktr,ktr_verbose," + \
+                   "rtems_bsd_descrip_trace,rtems_bsd_syscall_trace,rtems_bsd_vfs_trace")
     opt.add_option(
         "--optimization",
         action="store",
-- 
2.24.1

